# -*- coding: utf-8 -*-

import sys
import os

from PyQt4.QtGui import *
from PyQt4.QtCore import *
from PyQt4 import uic
from PyKDE4.kdeui import *
from PyKDE4.kdecore import *

# Define global path
PATH = '/usr/share/ubiquity'

#currently using for testing, will remove
UIDIR = os.path.join(PATH, 'qt')

class ProgressDialog(KMainWindow):
    def __init__(self, min, max, parent = None):
        QMainWindow.__init__(self, parent)
        uic.loadUi(os.path.join(UIDIR, "app-install.ui"), self)

        #self.setWindowFlags(Qt.SplashScreen | Qt.FramelessWindowHint)
        #self.setWindowFlags(Qt.SplashScreen | Qt.WindowStaysOnTopHint | Qt.WindowTitleHint)
        #self.setWindowFlags(Qt.WindowTitleHint | Qt.WindowCloseButtonHint)
        self.setWindowState(self.windowState() ^ Qt.WindowFullScreen)

        #self.progressLabel = QLabel()

        #self.progressBar = QProgressBar()
        self.progressBar.setMinimum(min)
        self.setMaximum(max)

        self.minimize_button.clicked.connect(self.showMinimized)

        #self.cancelButton = QPushButton()
        #self.cancelButton.clicked.connect(self.reject)

        #progressWidget = QWidget()
        #progressWidget.setLayout(QHBoxLayout())
        #progressWidget.layout().setContentsMargins(0,0,0,0)
        #progressWidget.layout().addWidget(self.progressBar)
        #progressWidget.layout().addWidget(self.cancelButton)

        #self.extraFrame = QFrame()
        #self.extraFrame.setFrameStyle(QFrame.StyledPanel)
        #self.extraFrame.setFrameShadow(QFrame.Sunken)
        self.extraFrame.setLayout(QVBoxLayout())
        self.extraFrame.layout().setContentsMargins(0,0,0,0)
        self.extraFrame.setVisible(False)

        #self.setLayout(QVBoxLayout())
        #self.layout().addWidget(self.progressLabel)
        #self.layout().addWidget(progressWidget)
        #self.layout().addWidget(self.extraFrame)

        self.bgImage = QImage("/usr/share/wallpapers/LE/contents/images/1920x1200.png")
        self.scaledBgImage = self.bgImage

        self.reset()

        #self.rejected.connect(self.rejectedSlot)

    def rejectedSlot(self):
        self.cancelFlag = True

    def paintEvent(self, pe):
        p = QPainter(self)
        p.drawImage(0, 0, self.scaledBgImage)

    def reset(self):
        self.cancelFlag = False
        self.progressLabel.setText("")
        self.windowTitle.setText("")
        self.progressBar.setValue(0)
        self.setVisible(False)
        self.cancelButton.setVisible(False)
        self.minimize_button.setVisible(False)
        self.progressLabel.setVisible(False)

    def wasCanceled(self):
        return self.cancelFlag

    def setCancelText(self, string):
        self.cancelButton.setText(string)

    def setCancellable(self, val):
        #self.cancelButton.setVisible(val)
        self.cancelButton.setVisible(False)

    def setMaximum(self, val):
        self.progressBar.setMaximum(val)

    def setProgressLabel(self, string):
        self.progressLabel.setText(string)

    def setProgressValue(self, val):
        self.progressBar.setValue(val)

    def maximum(self):
        return self.progressBar.maximum()
